# all files / ol/geom/flat/ geodesicflatgeom.js

67.61% Statements 48/71
50% Branches 4/8
71.43% Functions 5/7
67.61% Lines 48/71

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    1821×

    1×
    1×
    1×
    1×
    1×

    1×

    20×

    20×
    20×

    20×
    20×

    20×

    20×

    20×

    20×

    20×
    20×

    20×

    20×
    20×
    20×

    20×
    20×
    20×
    20×

    20×
    20×
    20×

    20×
    20×
    20×
    20×

    20×
    20×
    20×

    20×

    20×

    20×

    1×

    1×

    13×
    13×

    39×

    1×

    7×
    7×

    21×

     goog.provide('ol.geom.flat.geodesic');

    goog.require('goog.asserts');
    goog.require('goog.object');
    goog.require('ol.TransformFunction');
    goog.require('ol.math');
    goog.require('ol.proj');

    /**
     * @private
     * @param {function(number): ol.Coordinate} interpolate Interpolate function.
     * @param {ol.TransformFunction} transform Transform from longitude/latitude to
     *     projected coordinates.
     * @param {number} squaredTolerance Squared tolerance.
     * @return {Array.<number>} Flat coordinates.
     */
    ol.geom.flat.geodesic.line_ =
        function(interpolate, transform, squaredTolerance) {
      // FIXME reduce garbage generation
      // FIXME optimize stack operations

      /** @type {Array.<number>} */
      var flatCoordinates = [];

      var geoA = interpolate(0);
      var geoB = interpolate(1);

      var a = transform(geoA);
      var b = transform(geoB);

      /** @type {Array.<ol.Coordinate>} */
      var geoStack = [geoB, geoA];
      /** @type {Array.<ol.Coordinate>} */
      var stack = [b, a];
      /** @type {Array.<number>} */
      var fractionStack = [1, 0];

      /** @type {Object.<string, boolean>} */
      var fractions = {};

      var maxIterations = 1e5;
      var geoM, m, fracA, fracB, fracM, key;

      while (--maxIterations > 0 && fractionStack.length > 0) {
        // Pop the a coordinate off the stack
        fracA = fractionStack.pop();
        geoA = geoStack.pop();
        a = stack.pop();
        // Add the a coordinate if it has not been added yet
        key = fracA.toString();
        Eif (!goog.object.containsKey(fractions, key)) {
          flatCoordinates.push(a[0], a[1]);
          fractions[key] = true;
        }
        // Pop the b coordinate off the stack
        fracB = fractionStack.pop();
        geoB = geoStack.pop();
        b = stack.pop();
        // Find the m point between the a and b coordinates
        fracM = (fracA + fracB) / 2;
        geoM = interpolate(fracM);
        m = transform(geoM);
        Eif (ol.math.squaredSegmentDistance(m[0], m[1], a[0], a[1],
            b[0], b[1]) < squaredTolerance) {
          // If the m point is sufficiently close to the straight line, then we
          // discard it.  Just use the b coordinate and move on to the next line
          // segment.
          flatCoordinates.push(b[0], b[1]);
          key = fracB.toString();
          goog.asserts.assert(!goog.object.containsKey(fractions, key),
              'fractions object should contain key : ' + key);
          fractions[key] = true;
        } else {
          // Otherwise, we need to subdivide the current line segment.  Split it
          // into two and push the two line segments onto the stack.
          fractionStack.push(fracB, fracM, fracM, fracA);
          stack.push(b, m, m, a);
          geoStack.push(geoB, geoM, geoM, geoA);
        }
      }
      goog.asserts.assert(maxIterations > 0,
          'maxIterations should be more than 0');

      return flatCoordinates;
    };

    /**
    * Generate a great-circle arcs between two lat/lon points.
    * @param {number} lon1 Longitude 1 in degrees.
    * @param {number} lat1 Latitude 1 in degrees.
    * @param {number} lon2 Longitude 2 in degrees.
    * @param {number} lat2 Latitude 2 in degrees.
     * @param {ol.proj.Projection} projection Projection.
    * @param {number} squaredTolerance Squared tolerance.
    * @return {Array.<number>} Flat coordinates.
    */
    ol.geom.flat.geodesic.greatCircleArc = function(
        lon1, lat1, lon2, lat2, projection, squaredTolerance) {

      var geoProjection = ol.proj.get('EPSG:4326');

      var cosLat1 = Math.cos(ol.math.toRadians(lat1));
      var sinLat1 = Math.sin(ol.math.toRadians(lat1));
      var cosLat2 = Math.cos(ol.math.toRadians(lat2));
      var sinLat2 = Math.sin(ol.math.toRadians(lat2));
      var cosDeltaLon = Math.cos(ol.math.toRadians(lon2 - lon1));
      var sinDeltaLon = Math.sin(ol.math.toRadians(lon2 - lon1));
      var d = sinLat1 * sinLat2 + cosLat1 * cosLat2 * cosDeltaLon;

      return ol.geom.flat.geodesic.line_(
          /**
           * @param {number} frac Fraction.
           * @return {ol.Coordinate} Coordinate.
           */
          function(frac) {
            if (1 <= d) {
              return [lon2, lat2];
            }
            var D = frac * Math.acos(d);
            var cosD = Math.cos(D);
            var sinD = Math.sin(D);
            var y = sinDeltaLon * cosLat2;
            var x = cosLat1 * sinLat2 - sinLat1 * cosLat2 * cosDeltaLon;
            var theta = Math.atan2(y, x);
            var lat = Math.asin(sinLat1 * cosD + cosLat1 * sinD * Math.cos(theta));
            var lon = ol.math.toRadians(lon1) +
                Math.atan2(Math.sin(theta) * sinD * cosLat1,
                           cosD - sinLat1 * Math.sin(lat));
            return [ol.math.toDegrees(lon), ol.math.toDegrees(lat)];
          }, ol.proj.getTransform(geoProjection, projection), squaredTolerance);
    };

    /**
     * Generate a meridian (line at constant longitude).
     * @param {number} lon Longitude.
     * @param {number} lat1 Latitude 1.
     * @param {number} lat2 Latitude 2.
     * @param {ol.proj.Projection} projection Projection.
     * @param {number} squaredTolerance Squared tolerance.
     * @return {Array.<number>} Flat coordinates.
     */
    ol.geom.flat.geodesic.meridian =
        function(lon, lat1, lat2, projection, squaredTolerance) {
      var epsg4326Projection = ol.proj.get('EPSG:4326');
      return ol.geom.flat.geodesic.line_(
          /**
           * @param {number} frac Fraction.
           * @return {ol.Coordinate} Coordinate.
           */
          function(frac) {
            return [lon, lat1 + ((lat2 - lat1) * frac)];
          },
          ol.proj.getTransform(epsg4326Projection, projection), squaredTolerance);
    };

    /**
     * Generate a parallel (line at constant latitude).
     * @param {number} lat Latitude.
     * @param {number} lon1 Longitude 1.
     * @param {number} lon2 Longitude 2.
     * @param {ol.proj.Projection} projection Projection.
     * @param {number} squaredTolerance Squared tolerance.
     * @return {Array.<number>} Flat coordinates.
     */
    ol.geom.flat.geodesic.parallel =
        function(lat, lon1, lon2, projection, squaredTolerance) {
      var epsg4326Projection = ol.proj.get('EPSG:4326');
      return ol.geom.flat.geodesic.line_(
          /**
           * @param {number} frac Fraction.
           * @return {ol.Coordinate} Coordinate.
           */
          function(frac) {
            return [lon1 + ((lon2 - lon1) * frac), lat];
          },
          ol.proj.getTransform(epsg4326Projection, projection), squaredTolerance);
    };